class FactorAnalyzer{
//only for first factor or principal component
	computeLoadings(correlationMatrix, testNamesArray){//computes first factor loadings of the tests/variables
	 let stat = new Stat();
	 let numberOfTests = testNamesArray.length;
	 let totalSum = 0;
	 let sumPerTest = [];
	 let testLoadings = [];
	 let loading = 0;
	 let i;
	 for(i = 0; i < numberOfTests; i++){
	  sumPerTest[i] = stat.arraySum(correlationMatrix[i]);
	  totalSum += sumPerTest[i];
	 }
	 for(i = 0; i < numberOfTests; i++){
	  loading = sumPerTest[i] / Math.sqrt(totalSum);
	  testLoadings.push( [testNamesArray[i], loading] );
	 }
	 testLoadings = stat.sortObjectArrayByNumericalProperty(testLoadings, 1, 1);
	 return testLoadings;
	}

	computePropOfVarianceAccountedfor(correlationMatrix){//proportion of variance accounted for by the first factor
	 let stat = new Stat();
	 let numberOfTests = correlationMatrix.length;
	 let totalSum = 0;
	 let sumPerTest = [];
	 let testLoadings = [];
	 let i;
	 for(i = 0; i < numberOfTests; i++){
	  sumPerTest[i] = stat.arraySum(correlationMatrix[i]);
	  totalSum += sumPerTest[i];
	 }
	 for(i = 0; i < numberOfTests; i++)
	  testLoadings[i] = sumPerTest[i] / Math.sqrt(totalSum);
	 let sumOfSquares = 0;
	 for(i = 0; i < numberOfTests; i++)
	  sumOfSquares += testLoadings[i] ** 2;
	 return sumOfSquares / numberOfTests;
	}

	makeCorrelationTable(correlationMatrix, testNamesArray){
	 let stat = new Stat();
	 let numberOfTests = testNamesArray.length;
	 let source = "";
	 let i, j;
	 source += "<table class=\"margin\" border=\"1\" cellspacing=\"0\">\n";
	 source += "<tr><th>&nbsp;</th>";
	 for(i = 0; i < numberOfTests; i++)
	  source += "<th>" + testNamesArray[i] +  "</th>";
	 source += "</tr>\n"
	 for(i = 0; i < numberOfTests; i++){
	  source += "<tr><th>" + testNamesArray[i] + "</th>";
	 for(j = 0; j < numberOfTests; j++)
	  source += "<td>" + correlationMatrix[i][j].toFixed(2) +  "</td>";
	 source += "</tr>\n";
	 }
	 source += "</table>\n";
	 return source;
	}
}
//This code can be studied, used, distributed, and adapted freely by anyone
