class ItemAnalyzer{

	analyze(itemScoresMatrix, scoresArray){
	 let numberOfItems = itemScoresMatrix.length;
	 let itemAnalysisArray = [];
	 let i;
	 for(i = 0; i < numberOfItems; i++)
	  if(itemScoresMatrix[i].length > 0)
	   itemAnalysisArray[i] = { number: i + 1,
								hardness: this.itemHardness(itemScoresMatrix[i]),
								correlation: this.itemRestCorrelation(itemScoresMatrix[i], scoresArray) };
	  else
	   itemAnalysisArray[i] = { number: i + 1,
								hardness: NaN,
								correlation: NaN };
	 return itemAnalysisArray;
	}

	itemHardness(itemScoresArray){
	 let n = itemScoresArray.length;
	 let stat = new Stat();
	 let sum = 0;
	 if(n > 0){
		sum = stat.arraySum(itemScoresArray);
		return 1 - sum / n;
	} else
		return NaN;
	}
	
	itemRestCorrelation(itemScoresArray, totalScoresArray){
	 let n = itemScoresArray.length;
	 let restScoresArray = [];
	 let stat = new Stat();
	 let i;
	 for(i = 0; i < n; i++)
	  restScoresArray.push( totalScoresArray[i] - itemScoresArray[i] );
	 return stat.cor(itemScoresArray, restScoresArray);
	}
}
//This code can be studied, used, distributed, and adapted freely by anyone
