class Stat{
//general statistical functions
	arrayCopy(numArray){
	 let numbers = [];
	 let n = numArray.length;
	 let i;
	 for(i = 0; i < n; i++)
	   numbers.push( numArray[i] );
	  return numbers;
	}

	arraySum(numArray){
	 let sum = 0;
	 let n = numArray.length;
	 let i;
	 for(i = 0; i < n; i++)
	  sum += numArray[i];
	 return sum;
	}

	arraySumBelowIndex(numArray, index){
	 let sum = 0
	 let i;
	 for(i = 0; i < index; i++)
	  sum += numArray[i];
	 return sum;
	}

	arrayValueOfGivenRank(numArray, rank){//assumes array is sorted already!
	 if(isNaN(rank))
	  return -666;

	 if(rank % 1 === 0)
	  return numArray[rank];
	 else
	  return (numArray[Math.floor(rank)] + numArray[Math.ceil(rank)]) / 2;
	}
	
	congruence(xArray, yArray){//congruence coefficient, for instance to assess to what extent two vectors are the same
		let crossProductSum = 0;
		let xSquaresSum = 0;
		let ySquaresSum = 0;
		for(let i = 0; i < xArray.length; i++){
			crossProductSum += xArray[i] * yArray[i];
			xSquaresSum += xArray[i] ** 2;
			ySquaresSum += yArray[i] ** 2;
		}
		return crossProductSum / Math.sqrt(xSquaresSum * ySquaresSum);
	}

	cor(xArray, yArray){//pearson r correlation coefficient, arrays must contain paired data obviously
		return this.covariance(xArray, yArray) / (this.sdev(xArray) * this.sdev(yArray));
	}

	covariance(xArray, yArray){
	 let n = xArray.length;
	 let xMean = this.mean(xArray);
	 let yMean = this.mean(yArray);
	 let sumOfDeviationProducts = 0;
	 for(let i = 0;i < n; i++){
	  sumOfDeviationProducts += (xArray[i] - xMean) * (yArray[i] - yMean);
	 } 
	 return sumOfDeviationProducts / (n - 1);
	}

	freq(numArray, score){
	 let n = numArray.length;
	 let frequency = 0;
	 let i;
	 for(i = 0; i < n; i++)
	  if(numArray[i] === score)
	   frequency++;
	  return frequency;
	}

	hardness(average, maximum, minimum){
	 if(maximum === "&infin;" || maximum === Infinity)
	  return 1;
	 else if(maximum === undefined || isNaN(maximum) || isNaN(average))
	  return -1;
	 else if(minimum === undefined)
	  minimum = 0;
	 return (maximum - average) / (maximum - minimum); 
	}

	histoNumTable(numArray){//for when frequencies are so high that *** would not fit the page or screen
	 let numbers = this.arrayCopy(numArray);
	 numbers.sort(this.numsort);
	 let source = "<table class=\"margin\" border=\"1\" cellspacing=\"0\" cellpadding=\"0\">\n";
	 source += "<tr><th>Score</th><th>Frequency</th></tr>\n";
	 let n = numbers.length;
	 let frequency = 1;
	 let j;
	 for(j = 0; j < n; j++) {
	  if(j === 0)
	   source += "<tr><td>" + numbers[j] + "</td><td>";
	  else if(numbers[j] === numbers[j - 1])
	   frequency++;
	  else if(numbers[j] !== numbers[j - 1]){
	   source += frequency + "</td></tr>\n<tr><td>" + numbers[j] + "</td><td>";
	   frequency = 1;
	  }
	 }
	 source += frequency + "</td></tr>\n</table>\n";
	 return source;
	}

	histoTable(numArray){//with *** for frequencies
	 let numbers = this.arrayCopy(numArray);
	 numbers.sort(this.numsort);
	 let source = "<table class=\"margin\" cellspacing=\"0\" cellpadding=\"0\">\n";
	 let n = numbers.length;
	 let j;
	 for(j = 0; j < n; j++) {
	  if(j === 0)
	   source += "<tr><td>" + numbers[j] + "</td><td>&nbsp;*";
	  else if(numbers[j] === numbers[j - 1])
	   source += "*";
	  else if(numbers[j] !== numbers[j - 1])
	   source += "</td></tr>\n<tr><td>" + numbers[j] + "</td><td>&nbsp;*";
	 }
	 source += "</td></tr>\n</table>\n";
	 return source;
	}

	histoTableWithPropOutscored(numArray, numberOfDecimals){//with proportions outscored
	 let numbers = this.arrayCopy(numArray);
	 numbers.sort(this.numsort);
	 let source = "<table class=\"margin\" border=\"1\" cellspacing=\"0\" cellpadding=\"0\">\n";
	 source += "<tr><th>Score</th><th>Prop.</th><th># scores (* = 1 score)</th></tr>\n";
	 let n = numbers.length;
	 let j;
	 for(j = 0; j < n; j++) {
	  if(j === 0)
	   source += "<tr><td>" + numbers[j] + "</td><td>" + this.propOutscored(numbers, numbers[j], false).toFixed(numberOfDecimals) +
				" (" + this.propOutscored(numbers, numbers[j], true).toFixed(numberOfDecimals) + ")</td><td>&nbsp;*";
	  else if(numbers[j] === numbers[j - 1])
	   source += "*";
	  else if(numbers[j] !== numbers[j - 1])
	   source += "</td></tr>\n<tr><td>" + numbers[j] + "</td><td>" + this.propOutscored(numbers, numbers[j], false).toFixed(numberOfDecimals) +
				" (" + this.propOutscored(numbers, numbers[j], true).toFixed(numberOfDecimals) + ")</td><td>&nbsp;*";
	 }
	 source += "</td></tr>\n</table>\n";
	 return source;
	}

	mdev(numArray){//mean deviation
	 let numbers = this.removeUndefined(numArray);
	 let mean = this.mean(numbers);
	 let sum = 0;
	 let n = numbers.length;
	 let i;
	 for(i = 0; i < n; i++)
	  sum += Math.abs(numbers[i] - mean);
	 return sum / (n - 1);
	}

	mean(numArray){
	 let numbers = this.removeUndefined(numArray);
	 return this.arraySum(numbers) / numbers.length;
	}

	median(numArray){
	 let numbers = this.removeUndefined(numArray);
	 numbers.sort(this.numsort);
	 if(numbers.length % 2 === 1)
	  return numbers[numbers.length / 2 - 1/2];
	 else
	  return (numbers[numbers.length / 2 - 1] + numbers[numbers.length / 2]) / 2;
	}

	numsort(a, b){
		return a - b;
	}

	proportionOutscored(numArray, score){
	 let lower = 0;
	 let n = numArray.length;
	 let i;
	 for(i = 0; i < n; i++){
	   if(numArray[i] < score)
		lower++;
	   if(numArray[i] === score)
		lower += .5;
	 }
	 return lower / n;
	}

	propOutscored(numArray, score, forMissingValuesAboveScore){
	 let frequency = this.freq(numArray, score);
	 let lower = 0;
	 let n = numArray.length;
	 let i;
	 for(i = 0; i < n; i++)
	  if(numArray[i] < score)
	   lower++;
	 if(forMissingValuesAboveScore)
	  return (lower + frequency) / n;
	 else
	  return (lower + frequency / 2) / n;
	}

	protoPropOutscoredArray(numArray){
	 const OUTOF = 10000;
	 let n = numArray.length;
	 let sum = this.arraySum(numArray);
	 let ppoArray = [];
	 let i;
	 for(i = 0; i < n; i++)
	  ppoArray.push( Math.round(((this.arraySumBelowIndex(numArray, i) + numArray[i] / 2) / sum) * OUTOF) );
	 return ppoArray;
	}

	quartile13Array(numArray){//first and third quartiles
	 let numbers = this.removeUndefined(numArray);
	 numbers.sort(this.numsort);
	 let n = numbers.length
	 let q1 = 0;
	 let q3 = 0;
	 if(n % 4 === 0){
	  q1 = (numbers[n/4] + numbers[n/4 - 1]) / 2;
	  q3 = (numbers[n * 3/4] + numbers[(n * 3/4) - 1]) / 2;
	 } else{
	  q1 = numbers[Math.floor(n/4)];
	  q3 = numbers[Math.floor(n * 3/4)];
	 }
	 return [q1, q3];
	}

	qdev(numArray){//quartile deviation
	 let q13 = this.quartile13Array(numArray);
	 return (q13[1] - q13[0]) / 2;
	}

	range(numArray){
	 let numbers = this.removeUndefined(numArray);
	 return Math.max(...numbers) - Math.min(...numbers);
	}

	rank(numArray, score){//returns rank of score in numArray
	 let numbers = this.arrayCopy(numArray);
	 numbers.sort(this.numsort);
	 let sum = 0;
	 let n = numbers.length;
	 let counter = 0;
	 let i;
	 for(i = 0; i < n; i++)
	  if(numbers[i] === score){
	   sum += i;
	   counter++;
	  }
	 if(counter > 0)
	  return sum / counter;//rank starts at 0
	 else
	  return false;
	}

	rankArray(numArray){//turns array of numbers into array of corresponding ranks
	 let numbers = this.arrayCopy(numArray);
	 let n = numbers.length;
	 let ranks = [];
	 let i;
	 for(i = 0; i < n; i++)
	  ranks.push( this.rank(numbers, numbers[i]) );
	 return ranks;
	}

	rankCor(numArray1, numArray2){//rank correlation; this is naturally much more demanding on the cpu than is pearson r correlation
	 let ranks1 = this.rankArray(numArray1);
	 let ranks2 = this.rankArray(numArray2);
	 return this.cor(ranks1, ranks2);
	}

	rawToTScore(scoreArray, score){//linear T-score, not normalized
	 const MEAN = 50;
	 const SD = 10;
	 let z = this.zscore(scoreArray, score);
	 let tScore = z * SD + MEAN;
	 if(tScore < 0)
	  tScore = 0;
	 return tScore;
	}

	removeUndefined(numArray){
	 let numbers = [];
	 let n = numArray.length;
	 let i;
	 for(i = 0; i < n; i++)
	  if(numArray[i] !== undefined)
	   numbers.push( numArray[i] );
	  return numbers;
	}

	resolution(histo){
	 let resolution = 0;
	 if(!this.yieldsHalfPoints(histo))
	  resolution = this.qdev(histo);
	 else
	  resolution = this.qdev(histo) * 2;
	 return resolution;
	}

	rms(numArray){//root mean square average
	 let sumOfSquares = 0;
	 let n = numArray.length;
	 let i;
	 for(i = 0; i < n; i++)
	  sumOfSquares += numArray[i] ** 2;
	 return Math.sqrt(sumOfSquares / n);
	}

	sdev(numArray){//standard deviation
	 let numbers = this.removeUndefined(numArray);
	 let variance = this.variance(numbers);
	 return Math.sqrt(variance);
	}

	sortObjectArrayByNumericalProperty(objectArray, property, direction){//in case of array of arrays, property is non-negative integer; in case of array of objects, property is string
	 if(direction === 0)
	  return this.sortObjectArrayByNumericalPropertyAscending(objectArray, property);
	 else
	  return this.sortObjectArrayByNumericalPropertyDescending(objectArray, property);
	}

	sortObjectArrayByNumericalPropertyAscending(objectArray, property){
	 let n = objectArray.length;
	 let sor = true;
	 let check = 1;
	 let temp;
	 let i;
	 
	 while(sor){
	  if(check > 0){
	   check = 0;
	   for(i = 0; i < n - 1; i++){
		   if(objectArray[i][property] === undefined)
			   objectArray[i][property] = Infinity;
		   if(objectArray[i + 1][property] === undefined)
			   objectArray[i + 1][property] = Infinity;
		if(objectArray[i][property] > objectArray[i + 1][property]){
		 temp = objectArray[i];
		 objectArray[i] = objectArray[i + 1];
		 objectArray[i + 1] = temp;
		 check++;
		}
	   }
	  } else sor = false;
	 }
	 return objectArray;
	}

	sortObjectArrayByNumericalPropertyDescending(objectArray, property){
	 let n = objectArray.length;
	 let sor = true;
	 let check = 1;
	 let temp;
	 let i;
	 
	 while(sor){
	  if(check > 0){
	   check = 0;
	   for(i = 0; i < n - 1; i++){
		   if(objectArray[i][property] === undefined)
			   objectArray[i][property] = -Infinity;
		   if(objectArray[i + 1][property] === undefined)
			   objectArray[i + 1][property] = -Infinity;
		if(objectArray[i][property] < objectArray[i + 1][property]){
		 temp = objectArray[i];
		 objectArray[i] = objectArray[i + 1];
		 objectArray[i + 1] = temp;
		 check++;
		}
	   }
	  } else sor = false;
	 }
	 return objectArray;
	}

	standardError(scoresArray,reliability){
	 return this.sdev(scoresArray) * Math.sqrt(1 - reliability);
	}

	variance(numArray){
	 let mean = this.mean(numArray);
	 let n = numArray.length;
	 let sum = 0;
	 for(let i = 0; i < n; i++)
	  sum += (numArray[i] - mean) ** 2;
	 return sum / (n - 1);
	}

	yieldsHalfPoints(histo){
	const THRESHOLD = 4;
	let numberOfHalfPointScores = 0;
	for(let i = 0; i < histo.length; i++)
		if(histo[i] % 1 > 0)
			numberOfHalfPointScores++;

	return numberOfHalfPointScores < THRESHOLD ? false : true;
	}

	zscore(scoreArray, score){//linear z-score
		let sdev = 0;
		if(scoreArray.length < 3)
			return 0;
		else
			sdev = this.sdev(scoreArray);
	 if(sdev === 0)
	  return 0;//avoid dividing by zero
	 else
	  return (score - this.mean(scoreArray)) / sdev;	
	}
}
//This code can be studied, used, distributed, and adapted freely by anyone

